package com.example.tablesorting;

import java.util.Locale;

import javax.servlet.annotation.WebServlet;

import com.vaadin.annotations.Theme;
import com.vaadin.annotations.VaadinServletConfiguration;
import com.vaadin.data.Container;
import com.vaadin.data.Container.Indexed;
import com.vaadin.data.util.IndexedContainer;
import com.vaadin.data.util.converter.Converter;
import com.vaadin.server.VaadinRequest;
import com.vaadin.server.VaadinServlet;
import com.vaadin.ui.Grid;
import com.vaadin.ui.Grid.SelectionMode;
import com.vaadin.ui.UI;
import com.vaadin.ui.VerticalLayout;

@SuppressWarnings("serial")
@Theme("tablesorting")
public class TablesortingUI extends UI {

	@WebServlet(value = "/*", asyncSupported = true)
	@VaadinServletConfiguration(productionMode = false, ui = TablesortingUI.class)
	public static class Servlet extends VaadinServlet {
	}

	@Override
	protected void init(VaadinRequest request) {
		final VerticalLayout layout = new VerticalLayout();
		layout.setMargin(true);
		setContent(layout);

		Grid grid = new Grid();
		grid.setSelectionMode(SelectionMode.NONE);
		layout.addComponent(grid);
		
		Container container = new IndexedContainer();
		container.addContainerProperty("column1", Integer.class, null);
		container.addContainerProperty("column2", Integer.class, null);
		container.addContainerProperty("column3", Integer.class, null);
		for(int i=0; i<25; i++) {
			Object addItem = container.addItem();
			container.getItem(addItem).getItemProperty("column1").setValue(i);
			container.getItem(addItem).getItemProperty("column2").setValue(i);
			container.getItem(addItem).getItemProperty("column3").setValue(i%3);
		}
		
		grid.setContainerDataSource((Indexed) container);
		
		grid.getColumn("column3").setRenderer(new TestRenderer());
//		grid.getColumn("column3").setConverter(new TestConverter());
		
	}

}